Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/create_meshmask.f90	(revision 7153)
@@ -9,5 +9,7 @@
 !> @brief 
 !>  This program creates the NetCDF file(s) which contain(s) all the
-!>  ocean domain informations (mesh and mask arrays).
+!>  ocean domain informations.
+!>  It allows to create the domain_cfg.nc file needed to run NEMO, or 
+!>  the mesh_mask file(s).
 !>
 !> @details
@@ -26,5 +28,5 @@
 !>
 !> @section sec2 how to
-!>    to create meshmask file:<br/>
+!>    to create domain_cfg or meshmask file:<br/>
 !> @code{.sh}
 !>    ./SIREN/bin/create_meshmask create_meshmask.nam
@@ -34,5 +36,5 @@
 !>    you could find a template of the namelist in templates directory.
 !>
-!>    create_meshmask.nam contains 15 namelists:<br/>
+!>    create_meshmask.nam contains 13 namelists:<br/>
 !>       - logger namelist (namlog)
 !>       - config namelist (namcfg)
@@ -44,9 +46,9 @@
 !>       - partial step namelist (namzps)
 !>       - sigma or hybrid namelist (namsco)
-!>       - cross land advection namelist (namcla)
+!       - cross land advection namelist (namcla)
 !>       - lateral boundary condition namelist (namlbc)
 !>       - wetting and dryong namelist (namwd)
 !>       - grid namelist (namgrd)
-!>       - zoom namelist (namzoom)
+!       - zoom namelist (namzoom)
 !>       - output namelist (namout)
 !>
@@ -138,7 +140,7 @@
 !>          - dn_zb_b      : Offset for Zb
 !>
-!>    * _cross land advection namelist (namcla)_:<br/>
-!>       - in_cla : =1 cross land advection for exchanges through some straits (only for ORCA2)
-!>
+!    * _cross land advection namelist (namcla)_:<br/>
+!       - in_cla : =1 cross land advection for exchanges through some straits (only for ORCA2)
+!
 !>    * _lateral boundary condition namelist (namlbc)_:<br/>
 !>       - rn_shlat : lateral boundary conditions at the coast (modify fmask)
@@ -156,22 +158,22 @@
 !>    
 !>    * _grid namelist (namgrd)_:<br/>
-!>       - cn_cfg    : name of the configuration
-!>       - in_cfg    : resolution of the configuration
-!>       - in_bench  : benchmark parameter (in_mshhgr = 5 ).<br/>
-!>                     if /= 0 : forced the resolution to be about 100 km
-!>       - ln_zoom   : use zoom (namzoom)
+!       - cn_cfg    : name of the configuration
+!>       - in_cfg    : inverse resolution of the configuration (1/4° => 4)
+!>       - ln_bench  : GYRE (in_mshhgr = 5 ) used as Benchmark.<br/>
+!>                     => forced the resolution to be about 100 km
+!       - ln_zoom   : use zoom (namzoom)
 !>       - ln_c1d    : use configuration 1D
-!>
-!>    * _zoom namelist (namzoom)_:<br/>
-!>       - cn_cfz       : name of the zoom of configuration
-!>       - in_izoom     : left bottom i-indices of the zoom in data domain indices
-!>       - in_jzoom     : left bottom j-indices of the zoom in data domain indices
-!>       - ln_zoom_s    : South zoom type flag
-!>       - ln_zoom_e    : East  zoom type flag
-!>       - ln_zoom_w    : West  zoom type flag
-!>       - ln_zoom_n    : North zoom type flag
-!>
+!
+!    * _zoom namelist (namzoom)_:<br/>
+!       - cn_cfz       : name of the zoom of configuration
+!       - in_izoom     : left bottom i-indices of the zoom in data domain indices
+!       - in_jzoom     : left bottom j-indices of the zoom in data domain indices
+!       - ln_zoom_s    : South zoom type flag
+!       - ln_zoom_e    : East  zoom type flag
+!       - ln_zoom_w    : West  zoom type flag
+!       - ln_zoom_n    : North zoom type flag
+!
 !>    * _output namelist (namout)_:<br/>
-!>       - in_msh       : number of output file and contain (1-9)
+!>       - in_msh       : number of output file and contain (0-9)
 !>       - in_nproc     : number of processor to be used
 !>       - in_niproc    : i-direction number of processor
@@ -179,7 +181,8 @@
 !>
 !>    @note
-!>        MOD(in_msh, 3) = 1  :   '<b>mesh_mask.nc</b>' file
-!>                       = 2  :   '<b>mesh.nc</b>' and '<b>mask.nc</b>' files
-!>                       = 0  :   '<b>mesh_hgr.nc</b>', '<b>mesh_zgr.nc</b>' and '<b>mask.nc</b>' files
+!>        if     in_msh == 0  : write '<b>domain_cfg.nc</b>' file
+!>        MOD(in_msh, 3) = 1  :       '<b>mesh_mask.nc</b>' file
+!>                       = 2  :       '<b>mesh.nc</b>' and '<b>mask.nc</b>' files
+!>                       = 0  :       '<b>mesh_hgr.nc</b>', '<b>mesh_zgr.nc</b>' and '<b>mask.nc</b>' files
 !>
 !>        For huge size domain, use option 2 or 3 depending on your vertical coordinate.
@@ -197,4 +200,8 @@
 !> @date October, 2016
 !> - update from trunk (revision 6961): add wetting and drying, ice sheet coupling..
+!> @date October, 2016
+!> - dimension to be used select from configuration file
+!> - do not use anymore special case for ORCA grid
+!> - allow to write domain_cfg file
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -224,4 +231,6 @@
    CHARACTER(LEN=lc)                              :: cl_date
 
+   INTEGER(i1), DIMENSION(:)        , ALLOCATABLE :: bl_tmp
+
    INTEGER(i4)                                    :: il_narg
    INTEGER(i4)                                    :: il_status
@@ -232,7 +241,9 @@
    INTEGER(i4)                                    :: jpj
    INTEGER(i4)                                    :: jpk
+   INTEGER(i4), DIMENSION(:)        , ALLOCATABLE :: il_tmp
    INTEGER(i4), DIMENSION(:,:)      , ALLOCATABLE :: il_mask
 
    LOGICAL                                        :: ll_exist
+   LOGICAL                                        :: ll_domcfg
 
    REAL(dp)   , DIMENSION(:,:)      , ALLOCATABLE :: dl_tmp2D
@@ -241,4 +252,6 @@
    TYPE(TATT)                                     :: tl_att
    TYPE(TATT) , DIMENSION(:)        , ALLOCATABLE :: tl_gatt
+
+   TYPE(TDIM)                                     :: tl_dim
    
    TYPE(TVAR)                                     :: tl_bathy
@@ -249,4 +262,5 @@
    TYPE(TVAR)                                     :: tl_hdept
    TYPE(TVAR)                                     :: tl_hdepw
+   TYPE(TVAR)                                     :: tl_scalar
 
    TYPE(TNAMH)                                    :: tl_namh
@@ -278,6 +292,7 @@
 
    ! namcfg
-   CHARACTER(LEN=lc) :: cn_varcfg   = 'variable.cfg' 
-   CHARACTER(LEN=lc) :: cn_dumcfg   = 'dummy.cfg'
+   CHARACTER(LEN=lc) :: cn_varcfg   = './cfg/variable.cfg' 
+   CHARACTER(LEN=lc) :: cn_dimcfg   = './cfg/dimension.cfg'
+   CHARACTER(LEN=lc) :: cn_dumcfg   = './cfg/dummy.cfg'
 
    ! namin
@@ -301,5 +316,5 @@
 
    ! namout
-   INTEGER(i4)       :: in_msh      = 1 
+   INTEGER(i4)       :: in_msh      = 0 
    CHARACTER(LEN=lc) :: cn_type     = 'cdf'
    INTEGER(i4)       :: in_nproc    = 0
@@ -314,4 +329,5 @@
    NAMELIST /namcfg/ &  !< configuration namelist
    &  cn_varcfg, &       !< variable configuration file
+   &  cn_dimcfg, &       !< dimension configuration file
    &  cn_dumcfg          !< dummy configuration file
 
@@ -379,4 +395,7 @@
       CALL var_def_extra(TRIM(cn_varcfg))
 
+      ! get dimension allowed
+      CALL dim_def_extra(TRIM(cn_dimcfg))
+
       ! get dummy variable
       CALL var_get_dummy(TRIM(cn_dumcfg))
@@ -405,4 +424,8 @@
 
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+   ll_domcfg=.FALSE.
+   IF( in_msh == 0 )THEN
+      ll_domcfg=.TRUE.
+   ENDIF
 
    ! open file
@@ -443,5 +466,5 @@
         & tl_bathy%d_value(:,:,1,1) < 0._dp )
       tl_bathy%d_value(:,:,1,1) = 0._dp
-  END WHERE
+   END WHERE
  
    IF ( ln_isfcav ) THEN
@@ -495,9 +518,9 @@
 
    ! init Horizontal grid global variable
-   CALL grid_hgr_init(jpi,jpj,jpk)
+   CALL grid_hgr_init(jpi,jpj,jpk,ll_domcfg)
 
    ! compute horizontal mesh
    WRITE(*,*) "COMPUTE HORIZONTAL MESH"
-   CALL grid_hgr_fill(tl_namh,jpi,jpj)      
+   CALL grid_hgr_fill(tl_namh,jpi,jpj,ll_domcfg)      
 
    ! Vertyical  mesh (dom_zgr) -------------------------------------------------
@@ -505,5 +528,5 @@
 
    ! init Vertical grid global variable
-   CALL grid_zgr_init(jpi,jpj,jpk)
+   CALL grid_zgr_init(jpi,jpj,jpk,ln_sco)
    IF( ln_zps    ) CALL grid_zgr_zps_init(jpi,jpj)
    IF( ln_sco    ) CALL grid_zgr_sco_init(jpi,jpj) 
@@ -515,5 +538,5 @@
    ! compute masks
    WRITE(*,*) "COMPUTE MASK"
-   CALL create__mask(tl_namh,jpi,jpj,jpk)
+   CALL create__mask(tl_namh,jpi,jpj,jpk,ll_domcfg)
 
    ! Maximum stiffness ratio/hydrostatic consistency
@@ -534,72 +557,132 @@
 
    WRITE(*,*) "WRITE FILE(S)"
-   SELECT CASE ( MOD(in_msh, 3) )
-      !                                  ! ============================
-   CASE ( 1 )                            !  create 'mesh_mask.nc' file
-      !                                  ! ============================
-      tl_mppout0=mpp_init( 'mesh_mask', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-
-      tl_mppmsk=>tl_mppout0
-      tl_mpphgr=>tl_mppout0
-      tl_mppzgr=>tl_mppout0
+   IF( ll_domcfg )THEN
+         !                                  ! ============================
+         !                                  ! create 'domain_cfg.nc' file
+         !                                  ! ============================
+         tl_mppout0=mpp_init( 'domain_cfg', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+
+         tl_mppmsk=>tl_mppout0
+         tl_mpphgr=>tl_mppout0
+         tl_mppzgr=>tl_mppout0
+
+   ELSE
+      SELECT CASE ( MOD(in_msh, 3) )
+         !                                  ! ============================
+      CASE ( 1 )                            !  create 'mesh_mask.nc' file
+         !                                  ! ============================
+         tl_mppout0=mpp_init( 'mesh_mask', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+
+         tl_mppmsk=>tl_mppout0
+         tl_mpphgr=>tl_mppout0
+         tl_mppzgr=>tl_mppout0
+         
+         !                                  ! ============================
+      CASE ( 2 )                            !  create 'mesh.nc' and 
+         !                                  !         'mask.nc' files
+         !                                  ! ============================
+         tl_mppout0=mpp_init( 'mask', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+         tl_mppout1=mpp_init( 'mesh', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+
+         tl_mppmsk=>tl_mppout0
+         tl_mpphgr=>tl_mppout1
+         tl_mppzgr=>tl_mppout1
+
+         !                                  ! ============================
+      CASE ( 0 )                            !  create 'mesh_hgr.nc'
+         !                                  !         'mesh_zgr.nc' and
+         !                                  !         'mask.nc'     files
+         !                                  ! ============================
+         tl_mppout0=mpp_init( 'mask', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+         tl_mppout1=mpp_init( 'mesh_hgr', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+         tl_mppout2=mpp_init( 'mesh_zgr', tg_tmask, &
+         &                    in_niproc, in_njproc, in_nproc, &
+         &                    cd_type=cn_type )
+         !
+
+         tl_mppmsk=>tl_mppout0
+         tl_mpphgr=>tl_mppout1
+         tl_mppzgr=>tl_mppout2
+
+      END SELECT
+   ENDIF
+
+   ! add variables
+   IF( ll_domcfg )THEN
+      ALLOCATE(il_tmp(1))
+      tl_dim%l_use=.FALSE.
+
+      il_tmp(:)=jpi
+      tl_scalar=var_init('jpiglo', il_tmp(:), id_type=NF90_INT, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      il_tmp(:)=jpj
+      tl_scalar=var_init('jpjglo', il_tmp(:), id_type=NF90_INT, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      il_tmp(:)=jpk
+      tl_scalar=var_init('jpkglo', il_tmp(:), id_type=NF90_INT, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
       
-      !                                  ! ============================
-   CASE ( 2 )                            !  create 'mesh.nc' and 
-      !                                  !         'mask.nc' files
-      !                                  ! ============================
-      tl_mppout0=mpp_init( 'mask', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-      tl_mppout1=mpp_init( 'mesh', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-
-      tl_mppmsk=>tl_mppout0
-      tl_mpphgr=>tl_mppout1
-      tl_mppzgr=>tl_mppout1
-
-      !                                  ! ============================
-   CASE ( 0 )                            !  create 'mesh_hgr.nc'
-      !                                  !         'mesh_zgr.nc' and
-      !                                  !         'mask.nc'     files
-      !                                  ! ============================
-      tl_mppout0=mpp_init( 'mask', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-      tl_mppout1=mpp_init( 'mesh_hgr', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-      tl_mppout2=mpp_init( 'mesh_zgr', tg_tmask, &
-      &                    in_niproc, in_njproc, in_nproc, &
-      &                    cd_type=cn_type )
-      !
-
-      tl_mppmsk=>tl_mppout0
-      tl_mpphgr=>tl_mppout1
-      tl_mppzgr=>tl_mppout2
-
-   END SELECT
-
-   ! add variables
+      il_tmp(:)=tl_mppout0%i_perio
+      tl_scalar=var_init('jperio', il_tmp(:), id_type=NF90_INT, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      DEALLOCATE(il_tmp)
+      ALLOCATE(bl_tmp(1))
+
+      bl_tmp(:)=0
+      IF( ln_zco ) bl_tmp(:)=1
+      tl_scalar=var_init('ln_zco',bl_tmp(:), id_type=NF90_BYTE, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      bl_tmp(:)=0
+      IF( ln_zps ) bl_tmp(:)=1
+      tl_scalar=var_init('ln_zps',bl_tmp(:), id_type=NF90_BYTE, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      bl_tmp(:)=0
+      IF( ln_sco ) bl_tmp(:)=1
+      tl_scalar=var_init('ln_sco',bl_tmp(:), id_type=NF90_BYTE, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      bl_tmp(:)=0
+      IF( ln_isfcav ) bl_tmp(:)=1
+      tl_scalar=var_init('ln_isfcav',bl_tmp(:), id_type=NF90_BYTE, td_dim=tl_dim)
+      CALL mpp_add_var(tl_mppmsk, tl_scalar)
+
+      DEALLOCATE(bl_tmp)
+      CALL var_clean(tl_scalar)
+   ENDIF
+
    !!! mask (msk)
    !!!----------------------
-
-   ! tmask
-   CALL mpp_add_var(tl_mppmsk, tg_tmask)
-   CALL var_clean(tg_tmask)
-   ! umask
-   CALL mpp_add_var(tl_mppmsk, tg_umask)
-   CALL var_clean(tg_umask)
-   ! vmask
-   CALL mpp_add_var(tl_mppmsk, tg_vmask)
-   CALL var_clean(tg_vmask)
-   ! fmask
-   CALL mpp_add_var(tl_mppmsk, tg_fmask)
-   CALL var_clean(tg_fmask)
-
-   !!! VOIR CAS TMASKUTIL ???
-   
+   IF( .NOT. ll_domcfg )THEN
+      ! tmask
+      CALL mpp_add_var(tl_mppmsk, tg_tmask)
+      CALL var_clean(tg_tmask)
+      ! umask
+      CALL mpp_add_var(tl_mppmsk, tg_umask)
+      CALL var_clean(tg_umask)
+      ! vmask
+      CALL mpp_add_var(tl_mppmsk, tg_vmask)
+      CALL var_clean(tg_vmask)
+      ! fmask
+      CALL mpp_add_var(tl_mppmsk, tg_fmask)
+      CALL var_clean(tg_fmask)
+   ENDIF
+
    !!! horizontal mesh (hgr)
    !!!----------------------
@@ -662,44 +745,49 @@
 
    ! coriolis factor
-   ! ff
-   CALL mpp_add_var(tl_mpphgr, tg_ff)
-   CALL var_clean(tg_ff)
+   ! ff_t
+   CALL mpp_add_var(tl_mpphgr, tg_ff_t)
+   CALL var_clean(tg_ff_t)
+   ! ff_f
+   CALL mpp_add_var(tl_mpphgr, tg_ff_f)
+   CALL var_clean(tg_ff_f)
 
    ! angles
-   ! cost
-   CALL mpp_add_var(tl_mpphgr, tg_gcost)
-   CALL var_clean(tg_gcost)
-   ! cosu
-   CALL mpp_add_var(tl_mpphgr, tg_gcosu)
-   CALL var_clean(tg_gcosu)
-   ! cosv
-   CALL mpp_add_var(tl_mpphgr, tg_gcosv)
-   CALL var_clean(tg_gcosv)
-   ! cosf
-   CALL mpp_add_var(tl_mpphgr, tg_gcosf)
-   CALL var_clean(tg_gcosf)
-   
-   ! sint
-   CALL mpp_add_var(tl_mpphgr, tg_gsint)
-   CALL var_clean(tg_gsint)
-   ! sinu
-   CALL mpp_add_var(tl_mpphgr, tg_gsinu)
-   CALL var_clean(tg_gsinu)
-   ! sinv
-   CALL mpp_add_var(tl_mpphgr, tg_gsinv)
-   CALL var_clean(tg_gsinv)
-   ! sinf
-   CALL mpp_add_var(tl_mpphgr, tg_gsinf)
-   CALL var_clean(tg_gsinf)
+   IF( .NOT. ll_domcfg )THEN
+      ! cost
+      CALL mpp_add_var(tl_mpphgr, tg_gcost)
+      CALL var_clean(tg_gcost)
+      ! cosu
+      CALL mpp_add_var(tl_mpphgr, tg_gcosu)
+      CALL var_clean(tg_gcosu)
+      ! cosv
+      CALL mpp_add_var(tl_mpphgr, tg_gcosv)
+      CALL var_clean(tg_gcosv)
+      ! cosf
+      CALL mpp_add_var(tl_mpphgr, tg_gcosf)
+      CALL var_clean(tg_gcosf)
+      
+      ! sint
+      CALL mpp_add_var(tl_mpphgr, tg_gsint)
+      CALL var_clean(tg_gsint)
+      ! sinu
+      CALL mpp_add_var(tl_mpphgr, tg_gsinu)
+      CALL var_clean(tg_gsinu)
+      ! sinv
+      CALL mpp_add_var(tl_mpphgr, tg_gsinv)
+      CALL var_clean(tg_gsinv)
+      ! sinf
+      CALL mpp_add_var(tl_mpphgr, tg_gsinf)
+      CALL var_clean(tg_gsinf)
+   ENDIF
    
    !!! vertical mesh (zgr)
    !!!----------------------
-
    ! note that mbkt is set to 1 over land ==> use surface tmask
    ! 
    ! mbathy
    tg_mbathy%d_value(:,:,:,:) = tg_ssmask%d_value(:,:,:,:) * &
-      &                         tg_mbkt%d_value(:,:,:,:)
+   &                            tg_mbkt%d_value(:,:,:,:)
    !
+   IF( ll_domcfg ) tg_mbathy%c_name='bottom_level'
    CALL mpp_add_var(tl_mppzgr, tg_mbathy)
    CALL var_clean(tg_mbathy)
@@ -709,51 +797,57 @@
    dl_tmp2D(:,:)=dp_fill
 
-   tl_misf =var_init('misf    ',dl_tmp2D(:,:), id_type=NF90_INT)
+   tl_misf =var_init('misf     ',dl_tmp2D(:,:), id_type=NF90_INT)
 
    DEALLOCATE(dl_tmp2D)
    tl_misf%d_value(:,:,1,1) = tg_ssmask%d_value(:,:,1,1) * &
-      &                       tg_mikt%d_value(:,:,1,1)
+   &                          tg_mikt%d_value(:,:,1,1)
    !
+   IF( ll_domcfg ) tl_misf%c_name='top_level'
    CALL mpp_add_var(tl_mppzgr, tl_misf)
    CALL var_clean(tl_misf)
 
-   ! isfdraft
-   tl_risfdep%d_value(:,:,:,:) = tl_risfdep%d_value(:,:,:,:) * &
-      &                          tg_mikt%d_value(:,:,:,:)
-   CALL mpp_add_var(tl_mppzgr, tl_risfdep)
-   CALL var_clean(tl_risfdep)
+   IF( .NOT. ll_domcfg )THEN
+      ! isfdraft
+      tl_risfdep%d_value(:,:,:,:) = tl_risfdep%d_value(:,:,:,:) * &
+      &                             tg_mikt%d_value(:,:,:,:)
+ 
+      CALL mpp_add_var(tl_mppzgr, tl_risfdep)
+      CALL var_clean(tl_risfdep)
+   ENDIF
 
    IF( ln_sco ) THEN ! s-coordinate
 
-      ! hbatt
-      CALL mpp_add_var(tl_mppzgr, tg_hbatt)
-      CALL var_clean(tg_hbatt)
-      ! hbatu
-      CALL mpp_add_var(tl_mppzgr, tg_hbatu)
-      CALL var_clean(tg_hbatu)
-      ! hbatv
-      CALL mpp_add_var(tl_mppzgr, tg_hbatv)
-      CALL var_clean(tg_hbatv)
-      ! hbatf
-      CALL mpp_add_var(tl_mppzgr, tg_hbatf)
-      CALL var_clean(tg_hbatf)
-
-      ! scaling coef.
-      IF( .NOT. (tl_namz%l_s_sh94 .OR. tl_namz%l_s_sf12) )THEN
-         ! gsigt
-         CALL mpp_add_var(tl_mppzgr, tg_gsigt)
-         CALL var_clean(tg_gsigt)
-         ! gsigw
-         CALL mpp_add_var(tl_mppzgr, tg_gsigw)
-         CALL var_clean(tg_gsigw)
-         ! gsi3w
-         CALL mpp_add_var(tl_mppzgr, tg_gsi3w)
-         CALL var_clean(tg_gsi3w)
-         ! esigt
-         CALL mpp_add_var(tl_mppzgr, tg_esigt)
-         CALL var_clean(tg_esigt)
-         ! esigw
-         CALL mpp_add_var(tl_mppzgr, tg_esigw)
-         CALL var_clean(tg_esigw)
+      IF( .NOT. ll_domcfg )THEN
+         ! hbatt
+         CALL mpp_add_var(tl_mppzgr, tg_hbatt)
+         CALL var_clean(tg_hbatt)
+         ! hbatu
+         CALL mpp_add_var(tl_mppzgr, tg_hbatu)
+         CALL var_clean(tg_hbatu)
+         ! hbatv
+         CALL mpp_add_var(tl_mppzgr, tg_hbatv)
+         CALL var_clean(tg_hbatv)
+         ! hbatf
+         CALL mpp_add_var(tl_mppzgr, tg_hbatf)
+         CALL var_clean(tg_hbatf)
+
+         ! scaling coef.
+         IF( .NOT. (tl_namz%l_s_sh94 .OR. tl_namz%l_s_sf12) )THEN
+            ! gsigt
+            CALL mpp_add_var(tl_mppzgr, tg_gsigt)
+            CALL var_clean(tg_gsigt)
+            ! gsigw
+            CALL mpp_add_var(tl_mppzgr, tg_gsigw)
+            CALL var_clean(tg_gsigw)
+            ! gsi3w
+            CALL mpp_add_var(tl_mppzgr, tg_gsi3w)
+            CALL var_clean(tg_gsi3w)
+            ! esigt
+            CALL mpp_add_var(tl_mppzgr, tg_esigt)
+            CALL var_clean(tg_esigt)
+            ! esigw
+            CALL mpp_add_var(tl_mppzgr, tg_esigw)
+            CALL var_clean(tg_esigw)
+         ENDIF
       ENDIF
 
@@ -774,4 +868,5 @@
       ! Max. grid stiffness ratio
       ! rx1
+      IF( ll_domcfg ) tg_rx1%c_name='stiffness'
       CALL mpp_add_var(tl_mppzgr, tg_rx1)
       CALL var_clean(tg_rx1)
@@ -796,5 +891,5 @@
    IF( ln_zps ) THEN ! z-coordinate - partial steps
 
-      IF( in_msh <= 6 ) THEN ! 3D vertical scale factors
+      IF( ll_domcfg .OR. in_msh <= 6 ) THEN ! 3D vertical scale factors
 
          ! e3t_0
@@ -831,5 +926,5 @@
       ENDIF ! 3D vertical scale factors
 
-      IF( in_msh <= 3 ) THEN ! 3D depth
+      IF( ll_domcfg .OR. in_msh <= 3 ) THEN ! 3D depth
          
          ! gdept_0
@@ -837,31 +932,33 @@
       
          ! gdepu, gdepv
-         ALLOCATE(dl_tmp3D(jpi,jpj,jpk))
-         dl_tmp3D(:,:,:)=dp_fill
-
-         tl_gdepu=var_init('gdepu',dl_tmp3D(:,:,:), id_type=NF90_FLOAT)
-         tl_gdepv=var_init('gdepv',dl_tmp3D(:,:,:), id_type=NF90_FLOAT)
-
-         DEALLOCATE(dl_tmp3D)
-         DO jk = 1,jpk   
-            DO jj = 1, jpj-1   
-               DO ji = 1, jpi-1   ! vector opt.
-                  tl_gdepu%d_value(ji,jj,jk,1) = MIN( tg_gdept_0%d_value(ji  ,jj  ,jk,1) , &
-                     &                                tg_gdept_0%d_value(ji+1,jj  ,jk,1) )
-
-                  tl_gdepv%d_value(ji,jj,jk,1) = MIN( tg_gdept_0%d_value(ji  ,jj  ,jk,1) , &
-                     &                                tg_gdept_0%d_value(ji  ,jj+1,jk,1) )
+         IF( .NOT. ll_domcfg )THEN
+            ALLOCATE(dl_tmp3D(jpi,jpj,jpk))
+            dl_tmp3D(:,:,:)=dp_fill
+
+            tl_gdepu=var_init('gdepu',dl_tmp3D(:,:,:), id_type=NF90_FLOAT)
+            tl_gdepv=var_init('gdepv',dl_tmp3D(:,:,:), id_type=NF90_FLOAT)
+
+            DEALLOCATE(dl_tmp3D)
+            DO jk = 1,jpk   
+               DO jj = 1, jpj-1   
+                  DO ji = 1, jpi-1   ! vector opt.
+                     tl_gdepu%d_value(ji,jj,jk,1) = MIN( tg_gdept_0%d_value(ji  ,jj  ,jk,1) , &
+                        &                                tg_gdept_0%d_value(ji+1,jj  ,jk,1) )
+
+                     tl_gdepv%d_value(ji,jj,jk,1) = MIN( tg_gdept_0%d_value(ji  ,jj  ,jk,1) , &
+                        &                                tg_gdept_0%d_value(ji  ,jj+1,jk,1) )
+                  END DO   
                END DO   
-            END DO   
-         END DO         
-         CALL lbc_lnk( tl_gdepu%d_value(:,:,:,1), 'U', in_perio, 1._dp )
-         CALL lbc_lnk( tl_gdepv%d_value(:,:,:,1), 'V', in_perio, 1._dp )
-
-         ! gdepu
-         CALL mpp_add_var(tl_mppzgr, tl_gdepu)
-         CALL var_clean(tl_gdepu)
-         ! gdepv
-         CALL mpp_add_var(tl_mppzgr, tl_gdepv)
-         CALL var_clean(tl_gdepv)
+            END DO         
+            CALL lbc_lnk( tl_gdepu%d_value(:,:,:,1), 'U', in_perio, 1._dp )
+            CALL lbc_lnk( tl_gdepv%d_value(:,:,:,1), 'V', in_perio, 1._dp )
+
+            ! gdepu
+            CALL mpp_add_var(tl_mppzgr, tl_gdepu)
+            CALL var_clean(tl_gdepu)
+            ! gdepv
+            CALL mpp_add_var(tl_mppzgr, tl_gdepv)
+            CALL var_clean(tl_gdepv)
+         ENDIF
 
          ! clean
@@ -1133,8 +1230,9 @@
    DEALLOCATE(tl_gatt)
 
-   CALL grid_hgr_clean()
-   CALL grid_zgr_clean()
+   CALL grid_hgr_clean(ll_domcfg)
+   CALL grid_zgr_clean(ln_sco)
    IF( ln_zps    ) CALL grid_zgr_zps_clean()
    IF( ln_sco    ) CALL grid_zgr_sco_clean()
+   CALL var_clean_extra()
 
    ! close log file
@@ -1198,4 +1296,6 @@
    !> @author J.Paul
    !> @date September, 2015 - rewrite from dom_msk
+   !> @date October, 2016
+   !> - do not use anymore special case for ORCA grid
    !>
    !> @param[in] td_nam
@@ -1204,16 +1304,17 @@
    !> @param[in] jpk
    !-------------------------------------------------------------------
-   SUBROUTINE create__mask(td_nam,jpi,jpj,jpk) 
+   SUBROUTINE create__mask(td_nam,jpi,jpj,jpk,ld_domcfg) 
       IMPLICIT NONE
       ! Argument      
-      TYPE(TNAMH), INTENT(IN   ) :: td_nam
-      INTEGER(i4), INTENT(IN   ) :: jpi
-      INTEGER(i4), INTENT(IN   ) :: jpj
-      INTEGER(i4), INTENT(IN   ) :: jpk
+      TYPE(TNAMH), INTENT(IN) :: td_nam
+      INTEGER(i4), INTENT(IN) :: jpi
+      INTEGER(i4), INTENT(IN) :: jpj
+      INTEGER(i4), INTENT(IN) :: jpk
+      LOGICAL    , INTENT(IN) :: ld_domcfg
 
       ! local variable
-      INTEGER(i4)  ::   ii0, ii1  ! local integers
-      INTEGER(i4)  ::   ij0, ij1
-      INTEGER(i4)  ::   isrow
+!      INTEGER(i4)  ::   ii0, ii1  ! local integers
+!      INTEGER(i4)  ::   ij0, ij1
+!      INTEGER(i4)  ::   isrow
 
 !      INTEGER(i4), DIMENSION(:,:), ALLOCATABLE ::  imsk
@@ -1230,5 +1331,4 @@
 
 !      ALLOCATE( imsk(jpi,jpj) )
-      ALLOCATE( zwf(jpi,jpj) )
 
 !      ALLOCATE( dl_tpol(jpi) )
@@ -1304,4 +1404,5 @@
 !      ENDIF
 
+      IF( .NOT. ld_domcfg )THEN
       ! 2. Ocean/land mask at u-,  v-, and z-points (computed from tmask)
       ! -------------------------------------------
@@ -1366,4 +1467,5 @@
       ! Lateral boundary conditions on velocity (modify fmask)
       ! ---------------------------------------     
+      ALLOCATE( zwf(jpi,jpj) )
       DO jk = 1, jpk
          zwf(:,:) = tg_fmask%d_value(:,:,jk,1)         
